"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var state_kernel_1 = require("../state-kernel");
var routing_actions_1 = require("../redux/actions/routing-actions");
var history_reconciler_1 = require("./routing/history-reconciler");
var RoutingKernel = (function (_super) {
    __extends(RoutingKernel, _super);
    function RoutingKernel() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RoutingKernel.prototype.getState = function (fullState) {
        return fullState.routing;
    };
    RoutingKernel.prototype.handleStateChange = function (state) {
        this.reconcileHistories(state.history);
    };
    RoutingKernel.prototype.onFramework7Set = function () {
        this.initializeHistory();
    };
    RoutingKernel.prototype.initializeHistory = function () {
        var _this = this;
        if (this.mainView.history.length) {
            this.mainView.history.forEach(function (f7HistoryUrl) {
                _this.dispatchAction(routing_actions_1.navigateTo(f7HistoryUrl));
            });
        }
    };
    RoutingKernel.prototype.reconcileHistories = function (newHistory) {
        var _this = this;
        if (!this.router || !this.framework7)
            return;
        var reconciler = new history_reconciler_1.HistoryReconciler(this.router, this.mainView.history, newHistory);
        reconciler
            .getOperationsToReconcileHistories()
            .forEach(function (operation) {
            if (operation.forward) {
                _this.router.changeRoute(operation.url, _this.mainView, { reload: operation.replace, url: operation.url });
            }
            else {
                _this.mainView.router.back();
            }
        });
    };
    Object.defineProperty(RoutingKernel.prototype, "mainView", {
        get: function () {
            var mainView = this.framework7 && this.framework7.views && this.framework7.views.reduce(function (mainView, nextView) {
                if (nextView.main) {
                    return nextView;
                }
                else {
                    return mainView;
                }
            }, null);
            if (!mainView) {
                throw new Error('No main view found! A main view is required for routing.');
            }
            return mainView;
        },
        enumerable: true,
        configurable: true
    });
    return RoutingKernel;
}(state_kernel_1.StateKernel));
exports.RoutingKernel = RoutingKernel;

//# sourceMappingURL=routing-kernel.js.map
